/*
Geschrieben von KK
Ein Hkeldeckchen
Dicke : 1 mm (H =.1 weil 1pu = 1cm)
Seitenlnge ca. 15.5cm
//KK 22.9.00
*/

#local knubbel = 1;

#local H=.1;
#local B1 = 5;
#local B2 = 12;
#local P1_2 = 40;
#local B3 = 14;
#local P2_3 = 12;
#local B4 = 24;
#local P3_4 = 60; //= (4+1)*12

#local Radus = (B3*H+5/6*(B4-B3)*H+1/6*(B4-B3)*2.5*H+H);
#local Abs = (Radus*2-2*H)*cos(radians(360/P3_4*2.5));
#local Habs = (Abs+H)/2;

#local C1 = 5;
#local P_1_2 = 48;
#local Hi = Abs/2;
#local C2 =sqrt (2) * Hi - (Radus-H);


#local Ab = 1;

#macro Zyl (P1, P2, Ra)
 #if (knubbel)
  union {
   #local Di = P2-P1;
   #local Dis = vlength(Di);
   #local n = floor(Dis/(Ab*Ra));
   #local A = int(Dis/n);
   #local ca = 0;
   sphere {P1, Ra}
   #while (ca < n)
    #local ca = ca + 1;
    sphere {P1+Di*ca/n, Ra}
   #end
  }
 #else
  cylinder {P1, P2, Ra}
 #end 
#end

#local Teil1 =
 union {
  torus {B1*H,H}
  #local c=0;
  #while (c < P1_2)
   object {Zyl (<B1*H,0,0>,<B2*H,0,0>,H) rotate y*360*c/P1_2}
   #local c = c + 1;
  #end
  torus {B2*H, H} 
  #local c=0;
  #while (c < P2_3)
   object {Zyl (<B2*H,0,0>,<B3*H,0,0>,H) rotate y*360*c/P2_3}
   #local c = c + 1;
  #end
  torus {B3*H, H} 
  #local c=0;
  #while (c < P3_4)

   #local PosNew = <(B3+5/6*(B4-B3)+1/6*(B4-B3)*(abs(mod(c,5)-2.5)))*H,0,0>;
   #if (c!=0)
    union {
     object {Zyl (PosNew, PosOld, H)}
     sphere {PosNew, H}
     sphere {PosOld, H}
     rotate y*360*c/P3_4
    }
   #end 
   #if (mod(c,5)!=0)
    object {Zyl (<B3*H,0,0>,PosNew,H) rotate y*360*c/P3_4}
   #end 

   #local PosOld = vrotate (PosNew, y*360*-1/P3_4);
   #if (c=P3_4-1)
    union {
     #local PosNew = <(B3+5/6*(B4-B3)+1/6*(B4-B3)*(abs(mod(c+1,5)-2.5)))*H,0,0>;
     object { Zyl (PosNew, PosOld, H) }
     sphere {PosNew, H}
     sphere {PosOld, H}
     rotate y*360*c+1/P3_4
    }
   
   #end
   #local c = c + 1;
  #end
  rotate y*360*1/P3_4*2.5
 }

#local Teil2 =
 union {
  #local c = 0;
  torus {C1*H, H}
  #while (c < P_1_2)
   object {Zyl (<C1*H,0,0>,<C2,0,0>, H) rotate y*c/P_1_2*360}
   #local c = c + 1;
  #end
  torus {C2, H}
 }

union {
  object {Teil1}
  object {Teil1 translate <Abs,0,0>}
  object {Teil1 translate <-Abs,0,0>}
  object {Teil1 translate <0,0,Abs>}
  object {Teil1 translate <0,0,-Abs>}
  object {Teil1 translate <Abs,0,Abs>}
  object {Teil1 translate <-Abs,0,Abs>}
  object {Teil1 translate <Abs,0,-Abs>}
  object {Teil1 translate <-Abs,0,-Abs>}
  
  
  object {Teil2 translate <-Abs/2,0,-Abs/2>}
  object {Teil2 translate <Abs/2,0,-Abs/2>}
  object {Teil2 translate <-Abs/2,0,Abs/2>}
  object {Teil2 translate <Abs/2,0,Abs/2>}
  
  pigment {
   bozo
   color_map {
    [0.0 color rgb <1,1,.9>]
    [1.0 color rgb <.9,.9,.9*.9>]
   }
   scale H
  }
  normal {bozo .1}
  finish {ambient .2}

//  scale 1/(3*Abs)
}
